<template>
  <div class="row">
    <div class="col-12" v-if="action == 'update'">
      <b-form-group label="Id:">
        <b-form-input
          v-model="action_info.id"
          placeholder="Please enter your id"
          class="user-info user-info--radius"
          required
          disabled
        ></b-form-input>
      </b-form-group>
    </div>
    <div class="col-12" v-if="action == 'update'">
      <b-form-group label="Created Time:">
        <b-form-input
          v-model="action_info.createdDateTimeString"
          placeholder="Please enter date time"
          class="user-info user-info--radius"
          required
          disabled
        ></b-form-input>
      </b-form-group>
    </div>
    <div class="col-12">
      <b-form-group label="Name:">
        <b-form-input
          v-model="action_info.name"
          placeholder="Please enter your name"
          class="user-info user-info--radius"
          required
        ></b-form-input>
      </b-form-group>
    </div>
    <div class="col-12">
      <b-form-group label="Address:">
        <b-form-input
          v-model="action_info.address"
          placeholder="Please enter your address"
          class="user-info user-info--radius"
          required
        ></b-form-input>
      </b-form-group>
    </div>
    <div class="col-12">
      <b-form-group label="Avatar URL:">
        <b-form-input
          v-model="action_info.avatarURL"
          placeholder="Please enter your avatarURL"
          class="user-info user-info--radius"
          required
        ></b-form-input>
      </b-form-group>
    </div>
    <div class="col-12">
      <b-form-group label="Balance:">
        <b-form-input
          v-model="action_info.balance"
          placeholder="Please enter your balance"
          class="user-info user-info--radius"
          required
        ></b-form-input>
      </b-form-group>
    </div>
    <div class="col-12">
      <b-form-group label="Year of birth:">
        <b-form-select
          v-model="action_info.yearOfBirth"
          class="user-info user-info--radius"
          :options="optionsBirthYear"
          required
        ></b-form-select>
      </b-form-group>
    </div>
    <div class="col-12">
      <b-form-group label="Phone Number:">
        <b-form-input
          v-model="action_info.phoneNumber"
          placeholder="Please enter your phone number"
          class="user-info user-info--radius"
          @keypress="checkPhoneNumber"
          required
        ></b-form-input>
      </b-form-group>
    </div>
    <div class="col-12">
      <b-form-group
        label="Email address:"
        description="We'll never share your email with anyone else."
      >
        <b-form-input
          type="email"
          v-model="action_info.email"
          placeholder="Enter email"
          class="user-info user-info--radius"
          required
        ></b-form-input>
      </b-form-group>
    </div>
    <div class="col-12">
      <b-form-group label="Fax Number:">
        <b-form-input
          v-model="action_info.fax"
          placeholder="Please enter your fax number"
          class="user-info user-info--radius"
          @keypress="checkFaxNumber"
          required
        ></b-form-input>
      </b-form-group>
    </div>
    <div class="col-12 user-info-action user-info-action--align-right">
      <b-button
        v-if="action == 'update'"
        variant="primary"
        v-on:click="handleUpdateCustomer"
        class="btn-action btn-action--radius"
        >Update</b-button
      >
      <b-button
        v-if="action == 'add_new'"
        variant="primary"
        v-on:click="handleAddNewCustomer"
        class="btn-action btn-action--radius"
        >Add New</b-button
      >
    </div>
  </div>
</template>

<script>
import "./scss/UserInfoModal.scss";
import axios from "axios";

export default {
  name: "UserInfoModal",
  props: {
    action: {
      type: String,
      required: true,
      default: "update",
    },
    id: {
      type: Number,
      required: true,
      default: -1,
    },
  },
  data: () => ({
    action_info: {
      id: 0,
      name: "",
      address: "",
      avatarURL: "",
      balance: "",
      yearOfBirth: null,
      phoneNumber: "",
      email: "",
      fax: "",
      createdDateTimeString: "",
    }
  }),
  methods: {
    validatePhoneNumber(phoneNumber) {
      var phone_regex = /[0]{1}[3789]{1}[0-9]{8}/;
      if (phoneNumber.length != 10 || !phoneNumber.match(phone_regex))
        return false;
      return true;
    },
    validateFaxNumber(faxNumber) {
      var fax_regex = /[1-9]{1}[0-9]{6}/;
      if (faxNumber.length != 7 || !faxNumber.match(fax_regex)) return false;
      return true;
    },
    validateBalance(balance) {
      var balance_regex = /[1-9]{1}[0-9]*/;
      if (!Number(balance) || !String(balance).match(balance_regex))
        return false;
      return true;
    },
    validateEmail(email) {
      var email_regex =
        /^(([^<>()[\]\\.,;:\s@"]+(\.[^<>()[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
      if (!email.match(email_regex)) return false;
      return true;
    },
    validateBirthday(birthday){
      if (birthday === null){
        return false;
      }
      return true;
    },
    async handleUpdateCustomer() {
      if (!this.validatePhoneNumber(this.action_info.phoneNumber)) {
        // alert("Số điện thoại vừa nhập không phù hợp");
        this.$toaster.error("This phone number is invalid!!!", {
          timeout: 800,
        });
      } else if (!this.validateFaxNumber(this.action_info.fax)) {
        this.$toaster.error("This fax number is invalid!!!", { timeout: 800 });
      } else if (!this.validateBalance(this.action_info.balance)) {
        this.$toaster.error("This balance is invalid!!!", { timeout: 800 });
      } else if (!this.validateEmail(this.action_info.email)) {
        this.$toaster.error("This email is invalid!!!", { timeout: 800 });
      } else if (!this.validateBirthday(this.action_info.yearOfBirth)) {
        this.$toaster.error("Year of birthday is invalid!!!", { timeout: 800 });
      }
      else {
        var res = await axios.put(
          "https://ahasoft-sample-apis.azurewebsites.net/Customer",
          this.action_info
        );
        console.log("res put = ", res);
        this.$toaster.success("Update customer information successfully!!!", {
          timeout: 2000,
        });

        this.$emit("hideUserInfoModal");
        this.$emit("getCustomerList");
      }
    },
    async handleAddNewCustomer() {
      if (!this.validatePhoneNumber(this.action_info.phoneNumber)) {
        this.$toaster.error("This phone number is invalid!!!", {
          timeout: 800,
        });
      } else if (!this.validateFaxNumber(this.action_info.fax)) {
        this.$toaster.error("This fax number is invalid!!!", { timeout: 800 });
      } else if (!this.validateBalance(this.action_info.balance)) {
        this.$toaster.error("This balance is invalid!!!", { timeout: 800 });
      } else if (!this.validateEmail(this.action_info.email)) {
        this.$toaster.error("This email is invalid!!!", { timeout: 800 });
      } else {
        console.log("this.action_info.yearOfBirth = ", this.action_info.yearOfBirth);
        var payload = {
          id: 0,
          name: this.action_info.name,
          address: this.action_info.address,
          avatarURL: this.action_info.avatarURL,
          balance: Number(this.action_info.balance),
          yearOfBirth: Number(this.action_info.yearOfBirth),
          phoneNumber: this.action_info.phoneNumber,
          email: this.action_info.email,
          fax: this.action_info.fax,
          createdDateTimeString: this.action_info.createdDateTimeString,
        }
        console.log("payload = ", payload);
        var res = await axios.post("https://ahasoft-sample-apis.azurewebsites.net/Customer", payload);
        console.log(res);
        this.$emit("hideUserInfoModal");
        this.$toaster.success("Create user successfully!!!", { timeout: 2000 });
        this.$emit("getCustomerList");
      }
    },
    async getPersonalInfo() {
      var res = await axios.get(
        `https://ahasoft-sample-apis.azurewebsites.net/Customer/GetDetails?id=${this.id}`
      );
      if (res.status == 200) {
        this.action_info.id = res.data.id;
        this.action_info.name = res.data.name;
        this.action_info.address = res.data.address;
        this.action_info.avatarURL = res.data.avatarURL;
        this.action_info.balance = res.data.balance;
        this.action_info.yearOfBirth = res.data.yearOfBirth;
        this.action_info.phoneNumber = res.data.phoneNumber;
        this.action_info.email = res.data.email;
        this.action_info.fax = res.data.fax;
        this.action_info.createdDateTimeString = res.data.createdDateTimeString;
        this.selected = res.data.yearOfBirth;
      }
    },
    onlyNumber(e) {
      // console.log("$event.keyCode = ", e.keyCode); //keyCodes value
      if (e.keyCode == 8 || (e.keyCode >= 48 && e.keyCode <= 57)){
        return true;
      }
      else{
        return false;
      }
    },
    checkPhoneNumber($event){
      if (!this.onlyNumber($event) || this.action_info.phoneNumber.length === 10){
        $event.preventDefault();
      }
      else{
        return true;
      }
    },
    checkFaxNumber($event){
      if (!this.onlyNumber($event) || this.action_info.fax.length === 7){
        $event.preventDefault();
      }
      else{
        return true;
      }
    }
  },
  mounted() {
    if (this.action == "update") {
      this.getPersonalInfo();
    }
  },
  computed: {
    optionsBirthYear() {
      var list_option = [{ value: null, text: "Please select an option" }];
      var curr_year = new Date().getFullYear();
      for (var i = 1900; i <= curr_year; i++) {
        list_option.push({ value: i, text: i });
      }
      return list_option;
    },
  },
};
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
</style>